git-checkout: rewording comments regarding detached HEAD.
[gitweb.git] / git-checkout.sh
index 119bca1ffbfb8fb0dae404a8e7389f577aebc42c..3250f64ccc683606d420a82b3ec95e2f41bb52b3 100755 (executable)
@@ -6,6 +6,7 @@ SUBDIRECTORY_OK=Sometimes
 
 old_name=HEAD
 old=$(git-rev-parse --verify $old_name 2>/dev/null)
+oldbranch=$(git-symbolic-ref $old_name 2>/dev/null)
 new=
 new_name=
 force=
@@ -77,6 +78,11 @@ while [ "$#" != "0" ]; do
     esac
 done
 
+case "$force$merge" in
+11)
+       die "git checkout: -f and -m are incompatible"
+esac
+
 # The behaviour of the command with and without explicit path
 # parameters is quite different.
 #
@@ -107,7 +113,11 @@ Did you intend to checkout '$@' which can not be resolved as commit?"
                git-ls-tree --full-name -r "$new" "$@" |
                git-update-index --index-info || exit $?
        fi
-       git-checkout-index -f -u -- "$@"
+
+       # Make sure the request is about existing paths.
+       git-ls-files --error-unmatch -- "$@" >/dev/null || exit
+       git-ls-files -- "$@" |
+       git-checkout-index -f -u --stdin
        exit $?
 else
        # Make sure we did not fall back on $arg^{tree} codepath
@@ -130,20 +140,36 @@ fi
 
 [ -z "$new" ] && new=$old && new_name="$old_name"
 
-# If we don't have an old branch that we're switching to,
+# If we don't have an existing branch that we're switching to,
 # and we don't have a new branch name for the target we
-# are switching to, then we'd better just be checking out
-# what we already had
+# are switching to, then we are detaching our HEAD from any
+# branch.  However, if "git checkout HEAD" detaches the HEAD
+# from the current branch, even though that may be logically
+# correct, it feels somewhat funny.  More importantly, we do not
+# want "git checkout" nor "git checkout -f" to detach HEAD.
+
+if test -z "$branch$newbranch" && test "$new" != "$old"
+then
+       # NEEDSWORK: we would want to have a command here
+       # that allows us to detach the HEAD atomically.  Perhaps
+       # something like "git update-ref --detach HEAD $new"
+       echo "$new" >"$GIT_DIR/HEAD.new" &&
+       mv "$GIT_DIR/HEAD.new" "$GIT_DIR/HEAD" || die "Cannot detach HEAD"
 
-[ -z "$branch$newbranch" ] &&
-       [ "$new" != "$old" ] &&
-       die "git checkout: to checkout the requested commit you need to specify 
-              a name for a new branch which is created and switched to"
+       if test -n "$oldbranch"
+       then
+               echo >&2 "warning: you are not on ANY branch anymore.
+If you meant to create a new branch from the commit, you need -b to
+associate a new branch with the wanted checkout.  Example:
+  git checkout -b <new_branch_name> $arg
+"
+       fi
+fi
 
 if [ "X$old" = X ]
 then
-       echo "warning: You do not appear to currently be on a branch." >&2
-       echo "warning: Forcing checkout of $new_name." >&2
+       echo >&2 "warning: You appear to be on a branch yet to be born."
+       echo >&2 "warning: Forcing checkout of $new_name."
        force=1
 fi
 
@@ -152,7 +178,7 @@ then
     git-read-tree --reset -u $new
 else
     git-update-index --refresh >/dev/null
-    merge_error=$(git-read-tree -m -u $old $new 2>&1) || (
+    merge_error=$(git-read-tree -m -u --exclude-per-directory=.gitignore $old $new 2>&1) || (
        case "$merge" in
        '')
                echo >&2 "$merge_error"
@@ -163,7 +189,8 @@ else
        git diff-files --name-only | git update-index --remove --stdin &&
        work=`git write-tree` &&
        git read-tree --reset -u $new &&
-       git read-tree -m -u --aggressive $old $new $work || exit
+       git read-tree -m -u --aggressive --exclude-per-directory=.gitignore $old $new $work ||
+       exit
 
        if result=`git write-tree 2>/dev/null`
        then